chiark / gitweb /
test suite: Do not save non-world-readable artifacts
[dgit.git] / tests / lib
1 #
2
3 exec 2>&1
4 set -x
5 set -o pipefail
6
7 . tests/lib-core
8 . tests/lib-restricts
9
10 t-report-failure () {
11         set +x
12         rc=$1
13         cat <<END >&2
14 TEST FAILED
15 cwd: $PWD
16 funcs: ${FUNCNAME[*]}
17 lines: ${BASH_LINENO[*]}
18 files: ${BASH_SOURCE[*]}
19 END
20         t-save-artifacts
21
22         exit 16
23 }
24
25 trap 'test $? = 0 || t-report-failure' EXIT
26
27 t-filter-out-git-hyphen-dir
28
29 t-set-intree
30
31 : ${DGIT_TEST_DEBUG=-D}
32 export DGIT_TEST_DEBUG
33
34 : ${DGIT_TEST_DISTRO+ ${distro=${DGIT_TEST_DISTRO}}}
35
36 export GIT_COMMITTER_DATE='1515000000 +0100'
37 export GIT_AUTHOR_DATE='1515000000 +0100'
38
39 root=`pwd`
40 troot=$root/tests
41 testname="${DGIT_TEST_TESTNAME-${0##*/}}"
42 export DGIT_TEST_TROOT=$troot
43
44 tmp=$ADTTMP
45 if [ x"$tmp" = x ]; then
46         export DGIT_TEST_BYHAND=1
47         mkdir -p tests/tmp
48         tmpbase=$troot/tmp
49         tmp=tests/tmp/$testname
50         rm -rf $tmp
51         mkdir $tmp
52 elif [ "x$DGIT_TEST_TMPBASE" != x ]; then
53         tmpbase="$DGIT_TEST_TMPBASE"
54 fi
55 cd $tmp
56
57 tmp=`pwd`
58
59 t-set-using-tmp
60
61 test -f $tmp/.save-env || \
62 env -0 >$tmp/.save-env
63
64 ln -f $troot/ssh ssh
65
66 export DEBCHANGE_VENDOR=dpkg
67
68 mkdir -p $tmp/incoming
69 cat <<END >$tmp/dput.cf
70 [test-dummy]
71 method                  = local
72 incoming                = $tmp/incoming
73 run_dinstall            = 0
74 END
75
76 : ${t_archive_method:=aq}
77 : ${tagpfx:=archive/test-dummy}
78 : ${suitespecs:=sid:unstable}
79
80 t-git-next-date () {
81         GIT_COMMITTER_DATE="$(( ${GIT_COMMITTER_DATE%% *} + 1 )) ${GIT_COMMITTER_DATE#* }"
82         GIT_AUTHOR_DATE="$GIT_COMMITTER_DATE"
83 }
84
85 t-expect-fail () {
86         local mpat="$1"; shift
87
88         set +o pipefail
89         LC_MESSAGES=C "$@" 2>&1 | tee $tmp/t.output
90         local ps="${PIPESTATUS[*]}"
91         set -o pipefail
92
93         case $ps in
94         "0 0")  fail "command unexpectedly succeeded (instead of: $mpat)" ;;
95         *" 0")  ;;
96         *)      fail "tee failed"  ;;
97         esac
98
99         t-grep-mpat "$mpat" $tmp/t.output
100 }
101
102 t-grep-mpat () {
103         local mpat="$1"
104         local file="$2"
105
106         local grepper=fgrep
107         case "$mpat" in
108         [A-Z]:*)
109                 case "$mpat" in
110                 E:*)    grepper=egrep   ;;
111                 F:*)    grepper=fgrep   ;;
112                 *)      fail "bad mpat prefix in $mpat";;
113                 esac
114                 mpat=${mpat#[A-Z]:}
115                 ;;
116         esac
117
118         $grepper -e "$mpat" "$file" ||
119                 fail "message not found"
120 }
121
122 t-expect-push-fail () {
123         local mpat="$1"; shift
124
125         local triedpush; triedpush=`git rev-parse HEAD`
126
127         t-reporefs pre-push
128         t-expect-fail "$mpat"  "$@"
129         t-reporefs post-push
130         diff $tmp/show-refs.{pre,post}-push
131
132         t-git-objects-not-present '' $triedpush
133
134         eval "$t_expect_push_fail_hook"
135 }
136
137 t-git-objects-not-present () {
138         # t-git-objects-not-present GITDIR|'' OBJID [...]
139         # specifying '' means the repo for package $p
140         local gitdir="${1-$dgitrepo}"
141         local obj
142         if ! [ -e "$gitdir" ]; then return; fi
143         for obj in "$@"; do
144                 GIT_DIR=$gitdir \
145                 t-expect-fail 'unable to find' \
146                 git cat-file -t $obj
147         done
148 }
149
150 t-reporefs () {
151         local whichoutput=$1; shift
152         local whichrepo=${1-$dgitrepo}
153         local outputfile="$tmp/show-refs.$whichoutput"
154         (set -e
155          exec >"$outputfile"
156          if test -d $whichrepo; then
157                 cd $whichrepo
158                 git show-ref |t-sort
159         fi)
160 }
161
162 t-untar () {
163         local tarfile=$1.tar
164         local edittree=$1.edit
165         if test -d "$edittree"; then
166                 cp -a "$edittree"/* .
167         else
168                 tar xf "$tarfile"
169         fi
170 }
171
172 t-worktree () {
173         rm -rf $p
174         t-untar $troot/worktrees/${p}_$1
175 }
176
177 t-select-package () {
178         p=$1
179         dgitrepo=$tmp/git/$p.git
180 }
181
182 t-git () {
183         t-select-package $1
184         v=$2
185         mkdir -p $tmp/git
186         local gs=$troot/git-srcs/${p}_$v.git
187         (set -e; cd $tmp/git; t-untar $gs)
188 }
189
190 t-git-none () {
191         mkdir -p $tmp/git
192         (set -e; cd $tmp/git; tar xf $troot/git-template.tar)
193 }
194
195 t-salsa-add-remote () {
196         local d=$tmp/salsa/$p
197         mkdir -p $d
198         (set -e; cd $d; git init --bare)
199         git remote add ${1-origin} $d
200 }
201
202 t-git-merge-base () {
203         git merge-base $1 $2 || test $? = 1
204 }
205
206 t-has-ancestor () {
207         # t-has-ancestor ANCESTOR
208         # (CHILD is implicit, HEAD)
209         local now;      now=`git rev-parse HEAD`
210         local ancestor; ancestor=`git rev-parse $1^{}`
211         local mbase;    mbase=`t-git-merge-base $ancestor $now`
212         if [ x$mbase != x$ancestor ]; then
213                 fail "not ff $ancestor..$now, $mbase != $ancestor"
214         fi
215 }
216
217 t-has-parent-or-is () {
218         # t-has-parent-or-is CHILD PARENT
219         local child=$1
220         local parent=$2
221         local parents
222         parents=$(git show --pretty=format:' %P %H ' "$child")
223         parent=$(git rev-parse "$parent~0")
224         case "$parents" in
225         *" $parent "*)  ;;
226         *)      fail "child $child lacks parent $parent" ;;
227         esac
228 }
229
230 t-prep-newpackage () {
231         t-select-package $1
232         v=$2
233         t-archive-none $p
234         t-git-none
235         t-worktree $v
236         cd $p
237         if ! git show-ref --verify --quiet refs/heads/master; then
238                 git branch -m dgit/sid master
239                 git remote rm dgit
240         fi
241         cd ..
242 }
243
244 t-archive-none () {
245         t-select-package $1
246         t-archive-none-$t_archive_method
247 }
248 t-archive-none-aq () {
249         mkdir -p $tmp/aq/dsc_in_suite $tmp/mirror/pool/main
250
251         : >$tmp/aq/suites
252         local jsondelim="["
253
254         local suitespec
255         for suitespec in $suitespecs; do
256                 local suite=${suitespec%%:*}
257                 local sname=${suitespec#*:}
258
259                 >$tmp/aq/package.$suite.$p
260                 t-aq-archive-updated $suite $p
261
262                 >$tmp/aq/package.new.$p
263                 t-aq-archive-updated new $p
264
265                 ln -sf $suite $tmp/aq/dsc_in_suite/$sname
266
267                 cat <<END >>$tmp/aq/suites
268 $jsondelim
269    {
270       "archive" : "ftp-master",
271       "codename" : "$suite",
272       "components" : [
273          "main",
274          "contrib",
275          "non-free"
276       ],
277       "name" : "$sname",
278       "dakname" : "$sname"
279 END
280
281                 jsondelim="   },"
282
283         done
284         cat <<END >>$tmp/aq/suites
285     }
286 ]
287 END
288 }
289
290 t-aq-archive-updated () {
291         local suite=$1
292         local p=$2
293         local suitedir=$tmp/aq/dsc_in_suite/$suite
294         mkdir -p $suitedir
295         perl <$tmp/aq/package.$suite.$p >$suitedir/$p -wne '
296                 use JSON;
297                 use strict;
298                 our @v;
299                 m{^(\S+) (\w+) ([^ \t/]+)/(\S+)} or die;
300                 push @v, {
301                         "version" => "$1",
302                         "sha256sum" => "$2",
303                         "component" => "$3",
304                         "filename" => "$4",
305                 };
306                 END {
307                         my $json = JSON->new->canonical();
308                         print $json->encode(\@v) or die $!;
309                 }
310         '
311 }
312
313 t-archive-process-incoming () {
314         local suite=$1
315         mv $tmp/incoming/${p}_* $tmp/mirror/pool/main/
316         t-archive-query "$suite"
317 }
318
319 t-archive-query () {
320         local suite=${1-sid}
321         local dscf=main/${p}_${v}.dsc
322         t-archive-query-$t_archive_method "$suite" "$p" "$v" "$dscf"
323 }
324 t-archive-query-aq () {
325         local suite=$1
326         local p=$2
327         local v=$3
328         local dscf=$4
329         local sha; sha=`sha256sum <$tmp/mirror/pool/$dscf`
330         echo "${v} ${sha%  -} $dscf" >>$tmp/aq/package.$suite.${p}
331         t-aq-archive-updated $suite $p
332 }
333
334 t-archive () {
335         t-archive-none $1
336         v=$2
337         local dscf=${p}_$2.dsc
338         rm -f $tmp/mirror/pool/main/${p}_*
339         ln $troot/pkg-srcs/${p}_${2%-*}* $tmp/mirror/pool/main/
340         t-archive-query $suite
341         rm -rf $tmp/extract
342         mkdir $tmp/extract
343         (set -e; cd $tmp/extract; dpkg-source -x ../mirror/pool/main/$dscf)
344 }
345
346 t-git-dir-time-passes () {
347         touch -d 'last year' $dgitrepo
348 }
349
350 t-git-dir-check () {
351         local gitdir=$dgitrepo
352         case "$1" in
353         enoent)
354                 if test -e "$gitdir"; then fail "$gitdir exists"; fi
355                 return
356                 ;;
357         public) wantstat='7[75]5' ;;
358         secret) wantstat='7[70]0' ;;
359         *)      fail "$1 t-git-dir-check ?" ;;
360         esac
361         gotstat=`stat -c%a $gitdir`
362         case "$gotstat" in
363         *$wantstat) return ;;
364         *)      fail "$gitdir has mode $gotstat, expected $wantstat" ;;
365         esac
366 }
367
368 t-expect-fsck-fail () {
369         echo >>$tmp/fsck.expected-errors "$1"
370 }
371
372 t-git-fsck () {
373         local fsckerrs=$(git rev-parse --git-dir)/dgit-test-fsck.errs
374
375         set +e
376         LC_MESSAGES=C git fsck --no-dangling --strict 2>&1 \
377                 | tee $fsckerrs
378         ps="${PIPESTATUS[*]}"
379         set -e
380
381         local pats
382         if [ -f $tmp/fsck.expected-errors ]; then
383                 pats=(-w -f $tmp/fsck.expected-errors)
384         else
385                 test "$ps" = "0 0"
386         fi
387         pats+=(-e 'notice: HEAD points to an unborn branch')
388         pats+=(-e 'notice: No default references')
389
390         set +e
391         grep -v "${pats[@]}" $fsckerrs
392         rc=$?
393         set -e
394         case $rc in
395         1) ;; # no unexpected errors
396         0) fail "unexpected messages from git-fsck" ;;
397         *) fail "grep of git-fsck failed" ;;
398         esac
399 }
400
401 t-fscks () {
402         (
403         shopt -s nullglob
404         for d in $tmp/*/.git $tmp/git/*.git; do
405                 cd "${d%/.git}"
406                 t-git-fsck
407         done
408         )
409 }
410
411 t-ok () {
412         : '========================================'
413         t-fscks
414         t-save-artifacts
415         echo ok.
416 }
417
418 t-save-artifacts () {
419         artifacts="$AUTOPKGTEST_ARTIFACTS"
420         if [ x"$artifacts" = x ]; then return; fi
421         if [ x"tmp" = x ]; then return; fi
422         : '(((((((((( t-save-artifacts ))))))))))'
423         cp -dR --preserve=links,timestamps "$tmp"/. "$artifacts"/.
424         cd "$artifacts"/.
425         find . \( -name \*.tar -o -name \*.sample \) -print0 | \
426                 xargs -0r rm -v
427         find . \( -name .git \
428                 -o -path ./salsa/\* \
429                 -o -path ./git/\*.git \
430                 \) -type d \
431                 \! -path '*/.git/*/.git' -exec sh -xec '
432                         cd "$1"
433                         "$2"/playtree-save-refs
434                         git gc --prune=all
435                 ' x '{}' "$troot" \;
436         : ')))))))))) t-save-artifacts ))))))))))'
437 }
438
439 t-rm-dput-dropping () {
440         rm -f $tmp/${p}_${v}_*.upload
441 }
442
443 t-dgit () {
444         local dgit=${DGIT_TEST-dgit}
445         pwd >&2
446         : '
447 {{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{'
448         $dgit --dgit=$dgit --dget:-u --dput:--config=$tmp/dput.cf \
449  ${dgit_config_debian_alias-"--config-lookup-explode=dgit-distro.debian.alias-canon"} \
450  ${DGIT_GITDEBREBASE_TEST+--git-debrebase=}${DGIT_GITDEBREBASE_TEST} \
451                 ${distro+${distro:+-d}}${distro--dtest-dummy} \
452                 $DGIT_TEST_OPTS $DGIT_TEST_DEBUG \
453                 -kBCD22CD83243B79D3DFAC33EA3DBCBC039B13D8A $t_dgit_xopts "$@"
454         : '}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}
455 '
456 }
457
458 t-dgit-manpage () {
459         local section=$1
460         local page=$2
461         (export LC_ALL=C.UTF-8
462          if [ "$DGIT_TEST_INTREE" ]; then
463                 make -C $DGIT_TEST_INTREE $page.$section.view
464          else
465                 man $section $page
466          fi)
467 }
468
469 t-diff-nogit () {
470         diff --exclude=.git --exclude=.pc -ruN $*
471 }
472
473 t-files-notexist () {
474         local f
475         for f in "$@"; do
476                 if [ -e $f ]; then
477                         fail "$f exists!"
478                 fi
479         done
480 }
481
482 t-cloned-fetched-good () {
483         t-diff-nogit ../extract/$p-${v%-*} .
484         t-clean-on-branch dgit/sid
485         t-refs-same-start
486         t-refs-same \
487                 refs/heads/dgit/sid \
488                 refs/remotes/dgit/dgit/sid
489         t-refs-notexist refs/dgit/unstable refs/remotes/dgit/dgit/unstable
490 }
491
492 t-output () {
493         printf "%s${1:+\n}" "$1" >$tmp/t.want
494         shift
495         "$@" >$tmp/t.got
496         diff $tmp/t.want $tmp/t.got
497 }
498
499 t-clean-on-branch () {
500         t-output "## $1" git status -b --porcelain
501 }
502
503 t-setup-done () {
504         local savevars=$1
505         local savedirs=$2
506         local importeval=$3
507
508         local import=IMPORT.${DGIT_TEST_TESTNAME-${0##*/}}
509         exec 4>$tmp/$import.new
510
511         local vn
512         for vn in $savevars; do
513                 perl >&4 -"I$root" -MDebian::Dgit -e '
514                         printf "%s=%s\n", $ARGV[0], shellquote $ARGV[1]
515                 ' $vn "$(eval "printf '%s\n' \"\$$vn\"")"
516         done
517
518         (set -e; cd $tmp; tar cf $import.tar $savedirs)
519
520         printf >&4 "\n%s\n" "$importeval"
521
522         mv -f $tmp/$import.new $tmp/$import
523 }
524
525 t-setup-import () {
526         local setupname=$1
527
528         local setupsrc
529         local lock
530         if [ "x$tmpbase" = x ]; then
531                 # ADTTMP was set on entry to tests/lib, so we
532                 # are not sharing tmp area between tests
533                 setupsrc="$tmp"
534                 lock="$tmp/.dummy.lock"
535         else
536                 setupsrc="$tmpbase/$setupname"
537                 lock="$setupsrc.lock"
538         fi
539
540         local simport="$setupsrc/IMPORT.$setupname"
541
542         if ! [ -e "$simport" ]; then
543                 with-lock-ex -w "$lock" \
544                 xargs -0 -a $tmp/.save-env \
545                 bash -xec '
546                         cd "$1"; shift
547                         setupname="$1"; shift
548                         simport="$1"; shift
549                         if [ -e "$simport" ]; then exit 0; fi
550                         env - "$@" \
551                         "tests/setup/$setupname"
552                 ' x "$root" "$setupname" "$simport"
553         fi
554
555         if [ "x$setupsrc" != "x$tmp" ]; then
556                 (set -e; cd $tmp; tar xf "$simport.tar")
557         fi
558
559         . "$simport"
560 }
561
562 t-git-get-ref-exact () {
563         local ref=$1
564         # does not dereference, unlike t-git-get-ref
565         case "$ref" in
566         refs/*) ;;
567         *) fail "t-git-get-ref-exact bad $ref" ;;
568         esac
569         git for-each-ref --format='%(objectname)' "[r]efs/${ref#refs/}"
570 }
571
572 t-git-get-ref () {
573         local ref=$1
574         case "$ref" in
575         refs/*) ;;
576         *) fail "t-git-get-ref bad $ref" ;;
577         esac
578         (git show-ref -d $1 || test $? = 1) | perl -ne '
579                 $x = $1 if m#^(\w+) \Q'$1'\E(?:\^\{\})?$#;
580                 END { print "$x\n" if length $x; }
581         '
582 }
583
584 t-ref-same-exact () {
585         local name="$1"
586         local val; val=`t-git-get-ref-exact $name`
587         t-ref-same-val "$name" $val
588 }
589
590 t-ref-same () {
591         local name="$1"
592         local val; val=`t-git-get-ref $name`
593         t-ref-same-val "$name" $val
594 }
595
596 t-ref-head () {
597         local val; val=`git rev-parse HEAD`
598         t-ref-same-val HEAD $val
599 }
600
601 t-ref-same-val () {
602         local name="$1"
603         local val=$2
604         case "${t_ref_val-unset}" in
605         unset)          ;;
606         "$val")         ;;
607         *)              fail "ref varies: ($name)\
608  ${val:-nothing} != ${t_ref_val:-nothing} (${t_ref_names[*]})" ;;
609         esac
610         t_ref_val="$val"
611         t_ref_names+=("$name")
612 }
613
614 t-refs-same-start () {
615         unset t_ref_val
616         t_ref_names=()
617 }
618
619 t-refs-same () {
620         local g
621         for g in $*; do
622                 t-ref-same $g
623         done
624 }
625
626 t-refs-notexist () {
627         local val
628         for g in $*; do
629                 val=`t-git-get-ref $g`
630                 if [ "x$val" != x ]; then
631                         fail "ref $g unexpectedly exists ($val)"
632                 fi
633         done
634 }
635
636 t-v-tag () {
637         echo refs/tags/$tagpfx/${v//\~/_}
638 }
639
640 t-format-ref () {
641         git log -n1 --pretty=format:"$1" "$2"
642 }
643
644 t-sametree-parent () {
645         local ref=$1
646         local parent
647         local ctree; ctree=$(t-format-ref '%T' "$ref")
648         while :; do
649                 local psame=''
650                 for parent in $(t-format-ref '%P' "$ref"); do
651                         local ptree; ptree=$(t-format-ref '%T' "$parent")
652                         if [ "x$ptree" = "x$ctree" ]; then
653                                 psame+=" $parent"
654                         fi
655                 done
656                 case "$psame" in ""|" * *") break ;; esac
657                 ref="${psame# }"
658         done
659         echo "$ref"
660 }
661
662 t-check-pushed-master () {
663         local master; master=`t-git-get-ref refs/heads/master`
664         if [ x$master = x$t_ref_val ]; then return; fi
665         if [ x$master = x ]; then fail "failed to push master"; fi
666         # didn't update master, it must be not FF
667         local mbase; mbase=`t-git-merge-base $master $t_ref_val`
668         if [ x$mbase = x$master ]; then fail "failed to ff master"; fi
669 }
670
671 t-push-was-source-only () {
672         local f
673         t-files-notexist $tmp/incoming/${p}_${v}_*.deb \
674                          $tmp/incoming/${p}_${v}_*.udeb
675         # we permit _source.buildinfo files; see test_changes_source_only()
676         for f in $tmp/incoming/${p}_${v}_*.buildinfo; do
677             if [ -e $f ]; then
678                 case "$f" in
679                     *_source.buildinfo) ;;
680                     *) fail "non-source-only file $f exists!" ;;
681                 esac
682             fi
683         done
684 }
685
686 t-pushed-good () {
687         local branch=$1
688         local suite=${2:-sid}
689         t-refs-same \
690                 refs/heads/$branch
691         t-pushed-good-core
692 }
693         
694 t-pushed-good-core () {
695         t-ref-dsc-dgit
696         t-refs-same \
697                 `t-v-tag` \
698                 refs/remotes/dgit/dgit/$suite
699         t-refs-notexist \
700                 refs/heads/dgit/unstable \
701                 refs/remotes/dgit/dgit/unstable
702         (set -e; cd $dgitrepo
703          t-refs-same \
704                 refs/dgit/$suite \
705                 `t-v-tag`
706          ${t_check_pushed_master:- : NOT-DRS-NO-CHECK-PUSHED-MASTER}
707          t-refs-notexist \
708                 refs/dgit/unstable
709         )
710         git verify-tag `t-v-tag`
711 }
712
713 t-splitbrain-pushed-good--unpack () {
714         cd $tmp
715         rm -rf t-unpack
716         mkdir t-unpack
717         cd t-unpack
718         ln -s $tmp/mirror/pool/main/*.orig*.tar* .
719         ln -s $tmp/incoming/*.orig*.tar* . ||:
720         ln -s $incoming_dsc .
721         ln -s ${incoming_dsc/.dsc/.debian.tar}* .
722         dpkg-source "$@" -x *.dsc
723         cd */.
724         git init
725         git fetch ../../$p "refs/tags/*:refs/tags/*"
726 }
727
728 t-splitbrain-pushed-good--checkprep () {
729         git add -Af .
730         git rm --cached -r --ignore-unmatch .pc
731 }
732
733 t-splitbrain-pushed-good--checkdiff () {
734         local tag=$1
735         t-splitbrain-pushed-good--checkprep
736         t-output "" git diff --stat --cached $tag
737 }
738
739 t-splitbrain-pushed-good-start () {
740         dep14tag=refs/tags/test-dummy/${v//\~/_}
741         dgittag=$(t-v-tag)
742         t-output "" git status --porcelain
743         t-ref-head
744         t-refs-same $dep14tag
745         (set -e; cd $dgitrepo; t-refs-same $dep14tag)
746         git merge-base --is-ancestor $dep14tag $dgittag
747
748         t-refs-same-start
749         t-ref-same refs/heads/split.p
750         case "$(t-git-get-ref refs/heads/split.b)" in
751         "$t_ref_val") ;;
752         "$(git rev-parse refs/heads/split.p^0)") ;;
753         "$(git rev-parse refs/heads/split.p^1)") ;;
754         *) fail 'bad b/p' ;;
755         esac
756         t-pushed-good-core
757
758         t-incoming-dsc
759
760         t-splitbrain-pushed-good--unpack
761         t-splitbrain-pushed-good--checkdiff $dgittag
762 }
763 t-splitbrain-pushed-good-end-made-dep14 () {
764         t-splitbrain-pushed-good--checkdiff $dep14tag
765         cd $tmp/$p
766 }
767
768 t-splitbrain-rm-gitignore-patch () {
769         perl -i -pe '
770                 next unless $_ eq "auto-gitignore\n";
771                 die if $counter++;
772                 chomp;
773                 rename "debian/patches/$_", "../t-auto-gitignore" or die $!;
774                 $_ = "";
775         ' debian/patches/series
776 }
777
778 t-gbp-pushed-good () {
779         local suite=${1:-sid}
780         t-splitbrain-pushed-good-start
781
782         # Right, now we want to check that the maintainer tree and
783         # the dgit tree differ in exactly the ways we expect.  We
784         # achieve this by trying to reconstruct the maintainer tree
785         # from the dgit tree.
786
787         # So, unpack it withut the patches applied
788         t-splitbrain-pushed-good--unpack --skip-patches
789
790         # dgit might have added a .gitignore patch, which we need to
791         # drop and remove
792         t-splitbrain-rm-gitignore-patch
793
794         # Now the result should differ only in non-debian/ .gitignores
795         t-splitbrain-pushed-good--checkprep
796         git diff --cached --name-only $dep14tag >../changed
797         perl -ne '
798                 next if !m#^debian/# && m#(^|/)\.gitignore#;
799                 die "$_ mismatch";
800         ' <../changed
801
802         # If we actually apply the gitignore patch by hand, it
803         # should be perfect:
804         if [ -f ../t-auto-gitignore ]; then
805                 patch --backup-if-mismatch -p1 -u <../t-auto-gitignore
806         fi
807
808         t-splitbrain-pushed-good-end-made-dep14
809 }
810
811 t-unapplied-pushed-good () {
812         t-splitbrain-pushed-good-start
813         t-splitbrain-pushed-good--unpack --skip-patches
814         t-splitbrain-pushed-good-end-made-dep14
815 }
816
817 t-dpm-pushed-good () {
818         t-splitbrain-pushed-good-start
819         t-splitbrain-pushed-good--unpack
820         t-splitbrain-rm-gitignore-patch
821         t-splitbrain-pushed-good-end-made-dep14
822 }
823
824 t-commit-build-push-expect-log () {
825         local msg=$1
826         local mpat=$2
827         t-commit "$msg"
828         t-dgit build
829         LC_MESSAGES=C \
830         t-dgit push --new 2>&1 |tee $tmp/push.log
831         t-grep-mpat "$mpat" $tmp/push.log
832 }
833
834 t-822-field () {
835         local file=$1
836         local field=$2
837         perl -e '
838                 use Dpkg::Control::Hash;
839                 my $h = new Dpkg::Control::Hash allow_pgp=>1;
840                 $h->parse(\*STDIN,"'"$file"'");
841                 my $val = $h->{"'$field'"},"\n";
842                 die "'"$file $field"'" unless defined $val;
843                 print $val,"\n";
844         ' <$file
845 }
846
847 t-defdistro () {
848         export DGIT_TEST_DISTRO=''
849         distro=''
850         t-git-config dgit-suite.unstable.distro test-dummy
851 }
852
853 t-stunt-envvar () {
854         local var=$1
855         local tstunt=$2
856         eval '
857                 case "$'$var'" in
858                 "$tstunt:"*)    ;;
859                 *":$tstunt:"*)  ;;
860                 "")             '$var'="$tstunt" ;;
861                 *)              '$var'="$tstunt:$'$var'" ;;
862                 esac
863                 export '$var'
864         '
865 }
866
867 t-tstunt--save-real () {
868         local f="$1"
869         case "$f" in
870         */*) return ;;
871         esac
872
873         local rc
874         local real
875         set +e
876         real=$(
877                 p=":$PATH:"
878                 p="${p/:"$tmp/tstunt":/:}"
879                 p="${p%:}"
880                 p="${p#:}"
881                 PATH="$p"
882                 type -p "$f"
883         )
884         rc=$?
885         set -e
886
887         case $rc in
888         1)      return ;;
889         0)      ;;
890         *)      fail "did not find $f on PATH $PATH" ;;
891         esac
892
893         local varname=${f//[^_0-9a-zA-Z]/_}
894         varname=DGIT_TEST_REAL_${varname^^}
895
896         eval "
897                 : \${$varname:=\$real}
898                 export $varname
899         "
900 }
901
902 t-tstunt () {
903         local tstunt=$tmp/tstunt
904         t-stunt-envvar PATH $tstunt
905         t-stunt-envvar PERLLIB $tstunt
906         local f
907         for f in "$@"; do
908                 t-tstunt--save-real $f
909                 f="./$f"
910                 local d="$tstunt/${f%/*}"
911                 mkdir -p $d
912                 ln -sf "$troot/tstunt/$f" "$d"/.
913         done
914 }
915
916 t-tstunt-parsechangelog () {
917         t-tstunt dpkg-parsechangelog Dpkg/Changelog/Parse.pm
918 }
919
920 t-tstunt-lintian () {
921         t-tstunt lintian
922 }
923
924 t-tstunt-debuild () {
925         t-tstunt debuild
926 }
927
928 t-incoming-dsc () {
929         local dsc=${p}_${v}.dsc
930         incoming_dsc=$tmp/incoming/$dsc
931 }
932
933 t-ref-dsc-dgit () {
934         t-incoming-dsc
935         local val; val=`t-822-field $incoming_dsc Dgit`
936         val=$( perl -e '
937                 $_=shift @ARGV;
938                 die "Dgit $_ ?" unless m/^\w+\b/;
939                 print $&,"\n" or die $!;
940         ' "$val")
941         t-ref-same-val $incoming_dsc "$val"
942 }
943
944 t-apply-diff () {
945         local v1=$1
946         local v2=$2
947         (cd $troot/pkg-srcs;
948          debdiff ${p}_${v1}.dsc ${p}_${v2}.dsc || test $? = 1) \
949          | patch -p1 -u
950 }
951
952 t-gbp-unapplied-pq2qc () {
953         # does `gbp pq export'
954         # commits the resulting debian/patches on  qc/BRANCH
955         # leaves us on qc/BRANCH (eg "qc/quilt-tip"))
956         # qc/BRANCH is not fast-forwarding
957
958         gbp pq export
959
960         branch=`git symbolic-ref HEAD`
961         branch=${branch#refs/heads/}
962
963         case "$branch" in
964         */*) fail "unexpected branch $branch" ;;
965         esac
966
967         git branch -f qc/$branch
968         git checkout qc/$branch
969         git add debian/patches
970         git commit -m 'Commit patch queue'
971 }
972
973 t-git-pseudo-merge () {
974         # like   git merge -s ours
975         if [ ! "$git_pseuomerge_opts" ]; then
976                 if git merge --help \
977                  | grep -q allow-unrelated-histories; then
978                         git_pseuomerge_opts='--allow-unrelated-histories'
979                 fi
980                 git_pseuomerge_opts+=' -s ours'
981         fi
982         git merge $git_pseuomerge_opts "$@"
983 }
984
985 t-gbp-example-prep-no-ff () {
986         t-tstunt-parsechangelog
987         t-archive example 1.0-1
988         t-git-none
989         t-worktree 1.0
990
991         cd example
992
993         t-dgit fetch
994
995         git checkout -b patch-queue/quilt-tip-2 patch-queue/quilt-tip
996         gbp pq rebase
997
998         echo '/* some comment */' >>src.c
999         git add src.c
1000         git commit -m 'Add a comment to an upstream file'
1001
1002         t-gbp-unapplied-pq2qc
1003
1004         t-commit 'some updates' 1.0-2
1005 }
1006
1007 t-gbp-example-prep () {
1008         t-gbp-example-prep-no-ff
1009
1010         t-git-pseudo-merge \
1011                 -m 'Pseudo-merge to make descendant of archive' \
1012                 remotes/dgit/dgit/sid
1013 }
1014
1015 t-make-badcommit () {
1016         badcommit=$(
1017                 git cat-file commit HEAD | \
1018                 perl -pe 's/^committer /commiter /' | \
1019                 git hash-object -w -t commit --stdin
1020         )
1021         t-expect-fsck-fail $badcommit
1022 }
1023
1024 t-commit () {
1025         local msg=$1
1026         v=${2:-${majorv:-1}.$revision}
1027         dch --force-distribution -v$v --distribution ${3:-unstable} "$1"
1028         git add debian/changelog
1029         debcommit
1030         revision=$(( ${revision-0} + 1 ))
1031 }
1032
1033 t-dch-r-rune () {
1034         local cmd="$1"; shift
1035         local suite=${1-unstable}
1036         $cmd -r -D "$suite" ''
1037 }
1038
1039 t-dch-commit-r () {
1040         t-dch-r-rune t-dch-commit "$@"
1041 }
1042
1043 t-dch-commit () {
1044         faketime @"${GIT_AUTHOR_DATE% *}" dch "$@"
1045         git commit -m "dch $*" debian/changelog
1046 }
1047
1048 t-git-config () {
1049         git config --global "$@"
1050 }
1051
1052 t-drs () {
1053  t-git-config dgit-distro.test-dummy.git-url "ext::$troot/drs-git-ext %S "
1054  t-git-config dgit-distro.test-dummy.git-check true
1055  t-git-config dgit-distro.test-dummy.git-create true
1056  t-git-config dgit-distro.test-dummy.dgit-tag-format new,old,maint
1057         cp $troot/gnupg/{dd.gpg,dm.gpg,dm.txt} $tmp/.
1058         cp $troot/suites $tmp/.
1059         cp $troot/suites $tmp/suites-master
1060
1061         export t_check_pushed_master=t-check-pushed-master
1062
1063         drs_dispatch=$tmp/distro=test-dummy
1064         mkdir $drs_dispatch
1065
1066         if [ "x$DGIT_TEST_INTREE" != x ]; then
1067                 ln -sf "$DGIT_TEST_INTREE" $drs_dispatch/dgit-live
1068         fi
1069
1070         ln -sf $tmp/git $drs_dispatch/repos
1071         ln -sf $tmp/suites $tmp/suites-master $tmp/dm.txt $drs_dispatch/
1072         mkdir -p $drs_dispatch/keyrings
1073         ln -sf $tmp/dd.gpg $drs_dispatch/keyrings/debian-keyring.gpg
1074         ln -sf $tmp/dm.gpg $drs_dispatch/keyrings/debian-maintainers.gpg
1075         ln -sf /bin/true $drs_dispatch/policy-hook
1076 }
1077
1078 t-newtag () {
1079  export tagpfx=archive/test-dummy
1080  t-git-config dgit-distro.test-dummy.dgit-tag-format new,maint
1081 }
1082 t-oldtag () {
1083  export tagpfx=test-dummy
1084  t-git-config dgit-distro.test-dummy.dgit-tag-format old
1085 }
1086
1087 t-dsd () {
1088         t-drs
1089  t-git-config dgit-distro.test-dummy.ssh "$troot/dsd-ssh"
1090  t-git-config dgit-distro.test-dummy.git-check ssh-cmd
1091  t-git-config dgit-distro.test-dummy.git-create true
1092  t-git-config dgit-distro.test-dummy.git-url \
1093                 "ext::$troot/dsd-ssh X %S /dgit/test-dummy/repos"
1094
1095  t-git-config dgit-distro.test-dummy.diverts.drs /drs
1096  t-git-config dgit-distro.test-dummy/drs.ssh "$troot/ssh"
1097  t-git-config dgit-distro.test-dummy/drs.git-url $tmp/git
1098  t-git-config dgit-distro.test-dummy/drs.git-check ssh-cmd
1099  t-git-config dgit-distro.test-dummy/drs.git-create ssh-cmd
1100
1101         echo 'no-such-package* drs' >$drs_dispatch/diverts
1102 }
1103
1104 t-policy-admin () {
1105         : '(((((((((((((((((((((((((((((((((((((((('
1106         ${DGIT_INFRA_PFX}dgit-repos-admin-debian --repos $tmp/git "$@"
1107         : '))))))))))))))))))))))))))))))))))))))))'
1108 }
1109
1110 t-policy-nonexist () {
1111         ln -sf no-such-file-or-directory $drs_dispatch/policy-hook
1112 }
1113
1114 t-make-hook-link () {
1115         local hook=$1 # in infra/
1116         local linkpath=$2
1117         hook=${DGIT_INFRA_PFX}$hook
1118         case $hook in
1119         */*)    ;;
1120         *)      hook=`type -P $hook` ;;
1121         esac
1122         ln -sf "$hook" $linkpath
1123 }
1124
1125 t-policy () {
1126         local policyhook=$1
1127         t-make-hook-link $policyhook $drs_dispatch/policy-hook
1128 }
1129
1130 t-debpolicy () {
1131         t-dsd
1132         t-policy dgit-repos-policy-debian
1133
1134         mkdir $tmp/git
1135         t-policy-admin create-db
1136 }
1137
1138 t-policy-periodic () {
1139         : '(((((((((((((((((((((((((((((((((((((((('
1140         ${DGIT_REPOS_SERVER_TEST-dgit-repos-server} \
1141                 test-dummy $drs_dispatch '' --cron
1142         : '))))))))))))))))))))))))))))))))))))))))'
1143 }
1144
1145 t-restrict () {
1146         local restriction=$1
1147         (cd $root; t-restriction-$restriction >&2)
1148 }
1149
1150 t-dependencies () {
1151         : "Hopefully installed: $*"
1152 }
1153
1154 t-chain-test () {
1155         local ct=$1
1156         local d=${0%/*}
1157         cd $root
1158         export DGIT_TEST_TESTNAME="$testname"
1159         export DGIT_TEST_TMPBASE="$tmpbase"
1160         export ADTTMP=$tmp
1161         exec "$d/$ct"
1162 }       
1163
1164 t-alt-test () {
1165         local t=${0##*/}
1166         t-${t%%-*}
1167         t-chain-test "${t#*-}"
1168 }
1169
1170 t-git-config dgit.default.old-dsc-distro test-dummy
1171
1172 for import in ${autoimport-gnupg}; do
1173         case "$0" in
1174         */$import) ;;
1175         *)
1176                 t-setup-import $import
1177                 ;;
1178         esac
1179 done